
#include "Shapes.inc"
#include "Shapes2.inc"

#declare N1 = object { sphere { <0, 0, 0> 0.5 } }

#declare N2 = union {
    object { N1 }
    object { N1 scale 0.8 rotate 40*z rotate 34*x translate 0.22*x translate -0.3*y}
    object { N1 scale 0.9 rotate -53*z rotate 30*x translate 0.2*z  }
    object { N1 scale 0.7 rotate -35*x translate -0.1*x translate -0.3*y }
}

#declare N3 = union {
    object { N2 }
    object { N2 scale 0.8 rotate 13*z rotate 23*x translate 0.5*x }
    object { N2 scale 0.9 rotate -34*z rotate 47*x translate 0.7*y  }
    object { N2 scale 0.7 rotate -24*y translate -0.6*x translate -0.3*z }
}

#declare N4 = union {
    object { N3 }
    object { N3 scale 0.8 rotate 32*z rotate 65*x translate 0.9*x }
    object { N3 scale 0.9 rotate -15*y rotate 23*x translate 1.2*z  }
    object { N3 scale 0.7 rotate -55*x translate -0.7*y translate -0.9*z }
}

#declare N5 = union {
    object { N4 }
    object { N4 scale 0.8 rotate 65*z rotate 12*y translate 1.2*x }
    object { N4 scale 0.9 rotate -23*z rotate 36*x translate 0.7*z  }
    object { N4 scale 0.7 rotate -34*x translate -0.8*x translate -1.2*z }
}

#declare Model = union {
    object { N5 }
    object { N5 scale 0.7 rotate < -76,   2,  63> translate < 1.0, 1.0, 0.2> }
    object { N5 scale 0.8 rotate <  32, -9,  143> translate < 0.2,-1.2,-1.0> }
    object { N5 scale 0.9 rotate < -88, 120, 193> translate <-0.4,-1.0, 0.5> }
    object { N5 scale 0.7 rotate < 111,  57, -33> translate <-1.2,-0.4,-1.0> }
    object { N5 scale 1.1 rotate <-160, -82,-126> translate <-0.6,-0.8, 1.2> }
    object { N5 scale 0.9 rotate <  18,  22, -23> translate <-0.2,-1.2, 1.3> }
    object { N5 scale 0.8 rotate <-102, 162,  73> translate <-1.0, 0.8,-1.1> }
    object { N5 scale 1.0 rotate < -54,  34,  11> translate < 0.2,-0.8, 0.2> }
    object { N5 scale 0.8 rotate < -72,  65, 133> translate <-1.2,-0.2, 0.3> }
    object { N5 scale 1.1 rotate <  18,  84, 193> translate <-0.4, 1.0,-1.1> }
    object { N5 scale 0.8 rotate < 100,-111,-153> translate < 0.2,-1.2,-0.8> }
    object { N5 scale 1.0 rotate <  98, -54,  63> translate <-1.1,-0.7, 1.1> }
    object { N5 scale 0.8 rotate < -90,  34, 133> translate < 0.3, 1.0, 0.5> }
    object { N5 scale 0.7 rotate <  22,   8, -63> translate < 1.1, 0.4,-1.1> }
    object { N5 scale 0.9 rotate <-107,  86, -23> translate <-0.3,-0.8,-0.1> }
    object { N5 scale 1.0 rotate <  62, 142, -89> translate <   0,   0,-0.8> }
    object { N5 scale 0.9 rotate < -82, -16,-133> translate <-0.5, 0.4, 0.9> }
    object { N5 scale 0.9 rotate < -33,  29, -34> translate < 0.3, 0.5,-0.2> }
    object { N5 scale 1.1 rotate <  37, -76,-143> translate < 0.2,-1.0,-0.1> }
    object { N5 scale 0.7 rotate <  62,  54,  83> translate <-1.2, 0.6,-0.8> }
    object { N5 scale 1.0 rotate < 123, 150, 101> translate < 0.2,-0.2,-0.2> }
    object { N5 scale 0.7 rotate < -73,  -9, 123> translate <-1.2, 0.5, 1.0> }
    object { N5 scale 0.8 rotate < 150, -11,  23> translate < 0.3,-0.4, 1.1> }
    object { N5 scale 0.7 rotate <  45,  23,-153> translate < 0.4,-1.2,-1.0> }
    object { N5 scale 1.0 rotate <  26, -86, 133> translate <-1.0,-0.3, 1.0> }
    object { N5 scale 0.7 rotate <  72,  12, 103> translate <-0.4,-0.2,-0.7> }
    object { N5 scale 0.9 rotate <-127,  45, -33> translate < 1.1,-0.8,-0.3> }
    object { N5 scale 0.8 rotate <  25,-123, -45> translate < 0.3, 0.3, 0.2> }

    scale <2.6, 2.8, 2.7>
    texture {
        pigment { MainColor }
        finish {
            phong 0.3
            phong_size 1
            ambient 0.1
            diffuse 1
        }
    }
}
