
#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "finish.inc"
#include "glass.inc"
#include "metals.inc"
#include "stones.inc"
#include "woods.inc"

#include "..\Model.inc"

object { Model
    translate -0.7*z
    rotate -45*x
    translate <-0.1, -0.1, 0>
}

// ------ Shadow
union {
    box { <-4.4, -0.2, 5.6> <4.7, -0.1, -6.2> }
    box { <-0.15, -0.2, -0.15> <0.15, -0.1, 0.15> rotate 45*y translate <-4.45, 0, -5.95> }
    cylinder { <-1.5, -0.2, -5.95> <-1.5, -0.1, -5.95> 0.6 }
    cylinder { <2.5, -0.2, -5.95> <2.5, -0.1, -5.95> 0.6 }
    cylinder { <0, -0.2, 0> <0, -0.1, 0> 1 scale <1.3,1,0.2> translate <0.5, 0, -6.2> }

    texture { pigment { color rgb <97/255, 30/255, 111/255> } }
    finish {
        phong 0
        ambient 1
        diffuse 0
    }
    rotate -45*x
}

camera {
    location <0, 0, -100>
    up <0, 1, 0>
    right <1, 0, 0>
    angle 5.4
    orthographic
    look_at  0
}

background { color rgb <149/255, 34/255, 140/255> }

difference {
    sphere { <0, 0, 0> 200 }
    sphere { <0, 0, 0> 190 }
    plane { -z, -140 }
    pigment { color Gray }
}

//background { color Gray }

light_source { <-40, 160, -80> color White }
light_source { <0, 0, -100> color <0.8, 0.8, 0.8> shadowless }
